{*************************************}
{*                                   *}
{* Daniel Fernando Madeira RA 951752 *}
{* Turma MC101G                      *}
{* Calculadora verso 1.0            *}
{* Efetua expresses matemticas     *}
{* Concludo em 30/10/95             *}
{*                                   *}
{*************************************}

program calculadora;

uses wincrt,strings;

type strgmaxima=string;

var  p,n:integer; {p -> posio do ltimo caracter lido,n -> tamanho da formula}
     formula:string;{expresso digitada pelo usuario}
     resultado,memoria:real;
     error,divzero,raizneg,nipault:boolean; {indicaes de erro}
     tecla:char; {tecla digitada}

{****************************************************************************}

procedure apresentacao;

begin
  writeln('CALCULADORA para IBM/PC verso 1.0 - Windows - 30/10/95');
  writeln('Feita por Daniel F. Madeira RA 951752. Verso Shareware!');
  writeln;
  writeln('Entre com a expresso e tecle "=" para resolv-la.');
  writeln('Pressione <ESC> para sair!');
  writeln;
end;

{****************************************************************************}

procedure leitura; {L e calcula a expresso}

{***********************************************************************}

{Inicia o calculo}

function calcula_formula(var p:integer; strg:strgmaxima;
                         var error,divzero,raizneg,nipault:boolean):real;

var  r:real;{resultado parcial}
     i,poserro:integer;{poserro -> posio do erro}
     ch:char;{ltimo caracter lido}

{******************************************************************}

{Prepara a expresso para ser calculada e checa se houve algum erro}

procedure avalia(var formula:strgmaxima;
                 var valor:real;{resultado parcial}
                 var poserro:integer);

const numeros:set of char =['0'..'9','.'];

var  p,np:integer;{p -> posio do ltimo caracter lido,np -> nmero de parentesis}
     ch:char;{ltimo caracter lido}

{*************************************************************}

procedure proximoch; {L o prximo caracter na formula indicando sua posio}

begin
  repeat
   p:=p+1;                                      {Caso j tenha chegado no}
   if p <= length(formula) then ch:=formula[p]  {final da string  assumido}
                                                {o caracter #13}
                           else ch:=#13;        
  until (ch<>' ');                              
end;                                            
                                                
{*************************************************************}

function efetua:real;{Inicia os clculos}

var  e:real;{resultado de calculos no prioritarios}
     operador:char;{recebe o operador do clculo atual}

{********************************************************}

function prioridade:real; {Efetua as prioridades}

var  s:real;{resultado das prioridades}
     operador:char;

{***************************************************}

function defsinal:real; {Define o sinal da prioridade}

{**********************************************}

function checach:real; {Checa se o ltimo caracter lido  um nmero, um
                        parentesis que indica nova expresso, ou uma letra
                        que indica funo padro}

var  start:integer;{posio do primeiro caracter de um nmero dentro da string}
     f:real;{recebe o nmero, ou o resultado da nova expresso ou funo padro}

{*****************************************}

procedure processa_numero; {L o nmero dentro da string}

var code:integer;{posio do erro caso a substring no possa ser convertida
                  em nmero}
begin
  start:=p;
  repeat                             {L os prximos caracteres at que}
   proximoch;                        {no seja um nmero ou um dos dois}
  until not (ch in numeros);         {caracteres aceitos em nmero}
  if ch='.' then
      repeat                         {E finalmente converte a substring}
       proximoch;                    {do nmero encontrado para uma varivel}
      until not (ch in numeros);     {do tipo real}
  if ch='E' then
      begin
        proximoch;
        repeat
         proximoch;
        until not (ch in numeros);
      end;
  val(copy(formula,start,p-start),f,code);
end;

{*****************************************}

procedure processa_nova_expressao;{Inicia novamente os clculos para a nova
                                   expresso}

begin
  proximoch;                  {L o prximo caracter e efetua a nova }
  f:=efetua;                  {expresso, se o prximo caracter depois}
  if ch=')' then proximoch    {da nova expresso no for ')'  marcado}
            else poserro:=p;  {a posio do erro}
end;

{*****************************************}

procedure processa_funcao_padrao;{Calcula o valor das funes padro}

{******************}

function EelevX(x:real):real;{Calcula a funo de E elevado a X}

var t,st :real;{t -> valor do termo atual, st -> soma dos termos}
    k:integer;{contador dos termos}

begin
  if x < 0 then EelevX:=1/EelevX(abs(x)) {resolve uma frao se o expoente}
  else                                   {for negativo}
     begin
       t:=1; st:=t; k:=0;         {Atribui no termo zero o valor 1}

       while t > 1E-12 do         {Durante a repetio  calculado, a partir}
             begin                {do termo 1, o valor do termo, somando-se o}
               k := k + 1;        {valor do termo atual com a soma dos termos}
               t := t * x/k;      {j calculados}
               st := st + t;      {A repetio prossegue at que o termo k}
             end;                 {seja menor que 10^-12, o que nos da maior}
       EelevX := st;              {preciso no resultado}
     end;
end;

{******************}

begin
  if copy(formula,p,4)='SQRT' then          {Checa se a partir da letra }
      begin                                 {encontrada  formado o conjunto}
        p:=p+3;{pula o conjunto de letras}  {"SQRT" resolvendo ento a raiz}
        proximoch;{L o prximo caracter}   {quadrada do nmero ou expresso}
        if ch='-' then raizneg:=true        {que vira aps as letras}
        else                                {Se o prximo caracter for "-" ou}
           begin                            {o resultado da expresso for}
             f:=checach;                    {negativo sera retornado o erro}
             if f<0 then raizneg:=true      {de raiz negativa}
             else
                begin
                  f:=sqrt(f);
                end;
           end;
      end
  else if copy(formula,p,2)='E^' then       {Checa se a partir da letra}
      begin                                 {encontrada  formado o conjunto}
        p:=p+1;{pula o conjunto de letras}  {"E^" resolvendo ento a funo}
        proximoch;{L o prximo caracter}   {exponencial}
        f:=checach;
        f:=EelevX(f);
      end
  else
      begin
        poserro:=p; {Se a partir de uma letra no for encontrado um dos}
      end;          {conjuntos acima e marcada a posio do erro}
end;

{*****************************************}
                                           {Se o caracter for vlido para}
Begin                                      {nmero, o novo nmero ser}
  if (ch in numeros) then processa_numero  {capturado, se for parentesis}
  else if (ch='(') then                    { iniciado o clculo de uma nova}
          begin                            {expresso}

            np:=np+1;{Controla quantos parentesis foram encontrados}

            if np>6 then {Caso o limite de parentesis seja ultrapassado,}
               begin     { retornado erro}
                 nipault:=true;
                 processa_nova_expressao;{Inicia o clculo da nova expresso}
               end                       {para no interromper as operaes}
            else
               begin
                 processa_nova_expressao;{Inicia o clculo da nova expresso}
               end;
          end
  else processa_funcao_padrao; {Se o caracter for uma letra  iniciado o}
  checach:=f;                  {clculo da funo padro}
end;

{**********************************************}

begin
  if ch='-' then  {Se o caracter for "-" a prxima expresso ser negativa}
     begin
       proximoch; {L o proximo caracter}
       defsinal:=-checach;
     end
  else defsinal:=checach;
end;

{***************************************************}

begin
  s:=defsinal;
  while ch in ['*','/'] do
        begin
          operador:=ch; {L o operador}
          proximoch;  {L o proximo caracter}
          case operador of {Checa o operador e resolve a respectiva operao}
           '*': s:=s*defsinal;
           '/': begin
                  if defsinal=0 then divzero:=true {Se houver diviso por}
                  else                             {zero retorna erro}
                     begin
                       s:=s/defsinal;
                     end;
                end;
          end;
        end;
  prioridade:=s;
end;

{********************************************************}

begin
  e:=prioridade;  {Inicia prioridades}
  while ch in ['+','-'] do
        begin
          operador:=ch; {L o operador}
          proximoch;  {L o proximo caracter}
          case operador of {Checa o operador e resolve a respectiva operao}
           '+': e:=e+prioridade;
           '-': e:=e-prioridade;
          end;
        end;
  efetua:=e;
end;

{*************************************************************}
                                               {Caso a expresso inicie com}
begin                                          {ponto,  adicionado um zero}
  if formula[1]='.' then formula:='0'+formula; {antes. Se for sinal de mais}
  if formula[1]='+' then delete(formula,1,1);  {ele  apagado}
  p:=0; np:=0;                                 
  proximoch;  {L o proximo caracter}
  valor:=efetua;  {Efetua as contas}
  if ch=#13 then error:=false     {Caso o caracter no seja <ENTER>,que}
  else error:=true;               {indica que a expresso foi resolvida at}
  {recebe a posio do erro}      {o final, retorna erro}
  poserro:=p;                     
end;

{******************************************************************}

begin
  avalia(strg,r,p);     {Inicia a avaliao da expresso}
  calcula_formula:=r;
end;

{***********************************************************************}

{Os quatro procedimentos a seguir imprimem o aviso de erro na sada}

procedure erro_na_expressao;

var i:integer;

begin
  writeln;
  writeln('Erro! Expresso invlida!');
  writeln (formula);                    {Mostra a expresso e coloca o }
  for i:=1 to p-1 do write(' ');        {caracter "^" na posio p, que }
  writeln('^');                         {possui erro}
  writeln;
  write('ENTRADA>> ');
end;

{***********************************************************************}

procedure erro_no_parentesis;

begin
  writeln;
  writeln('Erro! Nvel de parentesis ultrapassado!');
  writeln;
  write('ENTRADA>> ');
  nipault:=false;
end;

{***********************************************************************}

procedure erro_na_divisao;

begin
  writeln;
  writeln('Erro! Diviso por zero!');
  writeln;
  write('ENTRADA>> ');
  divzero:=false;
end;

{***********************************************************************}

procedure erro_na_raiz;

begin
  writeln;
  writeln('Erro! Raiz de nmero negativo!');
  writeln;
  write('ENTRADA>> ');
  raizneg:=false;
end;

{***********************************************************************}

procedure memorizacao; {Gerencia o uso da memria}

var memo:string;{valor contido na memria que vai ser inserido na formula}

{**************************************}

procedure operacao_na_memoria;{Efetua as operaes na memria}

begin
  if formula<>'' then {Se alguma expresso foi digitada, inicia as operaes}
     begin
       {Inicia o calculo da expresso}
       resultado:=calcula_formula(p,formula,error,divzero,raizneg,nipault);

       {Checa se houve algum erro}
       if error then erro_na_expressao
       else if nipault then erro_no_parentesis
            else if divzero then erro_na_divisao
                 else if raizneg then erro_na_raiz
                      else
                         begin {Se no houve nenhum erro, efetua as operaes}
                           if tecla='+' then {Checa qual operador foi digitado}
                              begin
                                memoria:=memoria+resultado;
                                writeln;
			        writeln('SAIDA>> ',resultado:0:3,' adicionado na memria.');
                                writeln;
				write('ENTRADA>> ');
                              end
                           else
                              begin
                                memoria:=memoria-resultado;
                                writeln;
				writeln('SAIDA>> ',resultado:0:3,' subtraido da memria.');
                                writeln;
				write('ENTRADA>> ');
                              end;
                         end;
       resultado:=0;  {Limpa as variveis}
       formula:='';
     end
  else {Se no houver nada para adicionar ou subtrair da memria,retorna erro}
     begin
       if tecla='+' then {Checa qual operador foi digitado}
          begin
            writeln;
            writeln('Erro! No tem nada para adicionar na memria!');
            writeln;
	    write('ENTRADA>> ');
          end
       else
          begin
            writeln;
            writeln('Erro! No tem nada para subtrair da memria!');
            writeln;
	    write('ENTRADA>> ');
          end;
     end;
end;

{**************************************}

begin
  tecla:=readkey;               {Aps o usurio ter digitado <M> o programa}
  tecla:=upcase(tecla);         {l mais uma tecla efetuando a operao }
  write(tecla);                 {correspondente}
  case tecla of
       '+','-' : operacao_na_memoria;{Adiciona ou subtrai um valor na memria}

       'C' : begin  {Limpa a memria}
               memoria:=0;  
               writeln;
               writeln('Memria limpa!');
               writeln;
	       write('ENTRADA>> ');
             end;
       'R' : begin  {L a memria}
               if formula='' then     {Se no tiver nada na formula}
                  begin               {a memria  impressa no video}
                    writeln;
		    writeln('SAIDA>> ',memoria:0:3);
                    writeln;
                    write('ENTRADA>> ');
                  end
               else                         {Caso j tenha digitado algum}
                  begin                     {caracter para a formula, }
                    str(memoria,memo);      {adicionado o valor contido na}
                    formula:=formula+memo;  {memria  formula}
                  end;
             end;
  end;
end;

{***********************************************************************}

procedure igual;{Inicia os clculos aps o usurio ter digitado '=',
                 e imprime o resultado ou algum erro}

begin
  if formula <>'' then {Se tiver algum caracter na formula inicia o clculo}
     begin
       {Inicia o clculo da expresso}
       resultado:=calcula_formula(p,formula,error,divzero,raizneg,nipault);

       {Checa se houve algum erro ,tanto de digitao como de lgica}
       if error then erro_na_expressao
          else if nipault then erro_no_parentesis
               else if divzero then erro_na_divisao
                    else if raizneg then erro_na_raiz
                         else
                            begin {Se no houve erro, o resultado  mostrado}
                              writeln;
                              writeln('SAIDA>> ',resultado:0:3);
                              writeln;
			      write('ENTRADA>> ');
                            end;
       resultado:=0;  {Limpa as variveis}
       formula:='';
     end
  else     {Se a formula estiver vazia retorna erro}
     begin
       writeln;
       writeln('Erro! No tem nada para ser calculado!');
       writeln;
       write('ENTRADA>> ');
     end;
end;

{***********************************************************************}

{Leitura das teclas digitadas}

begin
  write('ENTRADA>> ');
  while tecla<>#27 do   {Enquanto no for pressionado <ESC> o programa vai}
        begin           {lendo as teclas digitadas}
          tecla:=readkey;
          tecla:=upcase(tecla);  {Transforma todas as letras em maisculas}
          write(tecla);
          case tecla of
               {letras vlidas para a expresso}
               '0'..'9','.','+','-','*','/','(',')','S','Q','R','T','E',
               '^' : formula:=formula+tecla;

               'C' : formula:=''; {Apaga a formula}

               '<' : begin
                       n:=length(formula); {L o tamanho da formula}
                       if n=0 then         {Se no tiver nada retorna erro}
                          begin
                            writeln;
                            writeln('Erro! No tem nada para apagar!');
                            writeln;
                            write('ENTRADA>> ');
                          end
                       else
                          delete(formula,n,1); {apaga o ultimo caracter}
                     end;

               'M' : memorizacao;

               '=' : igual;
          end;
        end;
end;

{****************************************************************************}

begin
  strcopy(windowtitle,'Calculadora'); {Altera o ttulo da janela}
  apresentacao;
  leitura;
  donewincrt; {Fecha janela no Windows}
end.
